## org.apache.lucene.analysis.it
Class ItalianAnalyzer

    java.lang.Object
      org.apache.lucene.analysis.Analyzer
          org.apache.lucene.analysis.ReusableAnalyzerBase
              org.apache.lucene.analysis.StopwordAnalyzerBase
                  org.apache.lucene.analysis.it.ItalianAnalyzer

All Implemented Interfaces:
  Closeable

    public final class ItalianAnalyzer

extends org.apache.lucene.analysis.StopwordAnalyzerBase

`Analyzer` for Italian.

You must specify the required `Version` compatibility when creating ItalianAnalyzer:

- As of 3.6, ItalianLightStemFilter is used for less aggressive stemming.
- As of 3.2, ElisionFilter with a set of Italian contractions is used by default.

Nested Class Summary

Nested classes/interfaces inherited from class org.apache.lucene.analysis.ReusableAnalyzerBase
`org.apache.lucene.analysis.ReusableAnalyzerBase.TokenStreamComponents`

Field Summary
`static String` `DEFAULT_STOPWORD_FILE` File containing default Italian stopwords.

Fields inherited from class org.apache.lucene.analysis.StopwordAnalyzerBase
`matchVersion, stopwords`

Constructor Summary
`ItalianAnalyzer(org.apache.lucene.util.Version matchVersion)` Builds an analyzer with the default stop words: `DEFAULT_STOPWORD_FILE`.
`ItalianAnalyzer(org.apache.lucene.util.Version matchVersion, Set<?> stopwords)` Builds an analyzer with the given stop words.
`ItalianAnalyzer(org.apache.lucene.util.Version matchVersion, Set<?> stopwords, Set<?> stemExclusionSet)` Builds an analyzer with the given stop words.

Method Summary
`protected org.apache.lucene.analysis.ReusableAnalyzerBase.TokenStreamComponents` `createComponents(String fieldName, Reader reader)` Creates a `ReusableAnalyzerBase.TokenStreamComponents` which tokenizes all the text in the provided `Reader`.
`static Set<?>` `getDefaultStopSet()` Returns an unmodifiable instance of the default stop words set.

Methods inherited from class org.apache.lucene.analysis.StopwordAnalyzerBase
`getStopwordSet, loadStopwordSet, loadStopwordSet, loadStopwordSet`

Methods inherited from class org.apache.lucene.analysis.ReusableAnalyzerBase
`initReader, reusableTokenStream, tokenStream`

Methods inherited from class org.apache.lucene.analysis.Analyzer
`close, getOffsetGap, getPositionIncrementGap, getPreviousTokenStream, setPreviousTokenStream`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DEFAULT_STOPWORD_FILE

    public static final String DEFAULT_STOPWORD_FILE

  File containing default Italian stopwords.

  See Also:
    Constant Field Values

Constructor Detail

### ItalianAnalyzer

    public ItalianAnalyzer(org.apache.lucene.util.Version matchVersion)

  Builds an analyzer with the default stop words: `DEFAULT_STOPWORD_FILE`.

### ItalianAnalyzer

    public ItalianAnalyzer(org.apache.lucene.util.Version matchVersion,
                           Set<?> stopwords)

  Builds an analyzer with the given stop words.

  Parameters:
    `matchVersion` - lucene compatibility version
    `stopwords` - a stopword set

### ItalianAnalyzer

    public ItalianAnalyzer(org.apache.lucene.util.Version matchVersion,
                           Set<?> stopwords,
                           Set<?> stemExclusionSet)

  Builds an analyzer with the given stop words. If a non-empty stem exclusion set is provided this analyzer will add a `KeywordMarkerFilter` before stemming.

  Parameters:
    `matchVersion` - lucene compatibility version
    `stopwords` - a stopword set
    `stemExclusionSet` - a set of terms not to be stemmed

Method Detail

### getDefaultStopSet

    public static Set<?> getDefaultStopSet()

  Returns an unmodifiable instance of the default stop words set.

  Returns:
    default stop words set.

### createComponents

    protected org.apache.lucene.analysis.ReusableAnalyzerBase.TokenStreamComponents createComponents(String fieldName,
                                                                                                     Reader reader)

  Creates a `ReusableAnalyzerBase.TokenStreamComponents` which tokenizes all the text in the provided `Reader`.

  Specified by:
    `createComponents` in class `org.apache.lucene.analysis.ReusableAnalyzerBase`
  Returns:
    A `ReusableAnalyzerBase.TokenStreamComponents` built from an `StandardTokenizer` filtered with `StandardFilter`, `ElisionFilter`, `LowerCaseFilter`, `StopFilter` , `KeywordMarkerFilter` if a stem exclusion set is provided and `ItalianLightStemFilter`.